module.exports = function(grunt) {

	require('time-grunt')(grunt);
	var adata = require('./build/src/load-data.js')(grunt);
	var less_custom_functions = require('./build/src/less-custom-functions.js')();


	grunt.initConfig({
		// pkg : grunt.file.readJSON('package.json'),
		"settings" : adata,
		"pr":adata.storage,
		"options":adata.options,
		jade : {
			compile : {
				options : {
					pretty: false,
					data : function(dest, src) {
						grunt.log.writeln('#################################################################');
						grunt.log.writeln(src);
						grunt.log.writeln('#################################################################');
						jdata = adata;
						jdata['debug'] = true;
						return jdata;
					}
				},
				files : {
					"target/includes/article-main.xhtml" : [ "<%=pr.src%>/article/article.jade" ]
				}
			}
		},




		////////////////////////////////////////////////////////////
		//	┏━╸┏━┓┏━┓╻ ╻
		//	┃  ┃ ┃┣━┛┗┳┛
		//	┗━╸┗━┛╹   ╹
		////////////////////////////////////////////////////////////
		copy : {
			'images-opt' : {
				files : [ {
					expand : true,
					flatten : true,
					src : [ '<%=pr.src%>/img/opt/**' ],
					dest : 'target/build/',
					filter : 'isFile'
				}, ],
			},
			'images-org' : {
				files : [ {
					expand : true,
					flatten : true,
					src : [ '<%=pr.src%>/img/org/**' ],
					dest : 'target/build/',
				 filter: function(filepath) {
					 if (grunt.file.isDir(filepath)) return false;
			     var dest  = 'target/build/'+ require('path').basename(filepath);
			     return !(grunt.file.exists(dest));
				 },
				}, ],
			},
			'js-src' : {
				files : [ {
					expand : true,
					flatten : true,
					src : [ '<%=pr.src%>/js/**', 'assets/js/**' ],
					dest : 'target/build/',
					filter : 'isFile'
				}, ],
			},
			'js-theme' : {
				files : [ {
					expand : true,
					flatten : true,
					src : [ 'themes/<%=settings.theme%>/js/**', 'assets/js/**' ],
					dest : 'target/build/',
					filter : 'isFile'
				}, ],
			},
			'css' : {
				files : [ {
					expand : true,
					flatten : true,
					src : [ 'assets/css/**', '<%=pr.src%>/css/**' ],
					dest : 'target/build/',
					filter : 'isFile'
				}, ],
			},

			'less-src' : {
				files : [ {
					expand : true,
					flatten : true,
					src : [  '<%=pr.src%>/less/**' ],
					dest :   'target/less/article',
					filter : 'isFile'
				}, ],
			},

			'less-templates' : {
				files : [ {
					expand : true,
					'cwd' : 'themes/<%=settings.theme%>/less',
					src : [  '**' ],
					dest :   'target/less/',
					//filter : 'isFile'
				}, ],
			},


			'less-variables' : {
				files : [ {
					src : '<%=pr.src%>/data/style.less' ,
					dest : 'target/less/overwrites.less',
				}, ],
			},

			//			fonts : {
//				files : [ {
//					expand : true,
//					flatten : true,
//					src : [ 'assets/fonts/**', '<%=pr.src%>/fonts/**' ],
//					dest : 'target/build/',
//					filter : 'isFile'
//				}, ],
//			},

			'fragments-src' : {
				files : [ {
					expand : true,
					cwd : '<%=pr.src%>/article/fragments/',
					src : [ '**' ],
					dest : 'target/includes/',
					filter : 'isFile'
				}, ],
			},

			'includes-src' : {
				files : [ {
					expand : true,
					cwd : '<%=pr.src%>/article/',
					src : [ 'article-*.html' ],
					dest : 'target/includes/',
					filter : 'isFile'
				}, ],
			},

			'article-html-src' : {
				files : [ {
					src : '<%=pr.src%>/article/article.html',
					dest : 'target/includes/article-main.xhtml',
				}, ],
			},

			'templates' : {
				files : [ {
					expand : true,
					cwd : 'themes/<%=settings.theme%>/templates/',
					src : [ '*' ],
					dest : 'target/includes/',
					filter : 'isFile'
				}, ],
			},
			'template-fragments' : {
				files : [ {
					expand : true,
					cwd : 'themes/<%=settings.theme%>/templates/fragments/',
					src : [ '**' ],
					dest : 'target/includes/',
					filter : 'isFile'
				}, ],
			},

			rimages : {
				files : [ {
					expand : true,
					cwd : 'target/rdata/',
					src : [ '*.png', '*.svg' ],
					dest : '<%=pr.src%>/img/org/generated/',
					filter : 'isFile'
				}, ],
			},
			rdata : {
				files : [ {
					expand : true,
					cwd : 'target/rdata/',
					src : [ '*.json' ],
					dest : '<%=pr.src%>/data/generated/',
					filter : 'isFile'
				}, ],
			},
			'article-body-article' : {
				files : [ {
					src : 'target/includes/article.xhtml',
					dest : 'target/includes/index.html',
				}, ],
			},
			'dom-transform-replacement': {
				files : [ {
					src : 'target/build/article.xhtml',
					dest : 'target/build/watch.html'
				}, ],

			},
			'inlineToDist' : {
				files : [ {
					src : [ 'target/build/inline.html' ],
					dest : '<%= distfilepath %>'
				}, ],
			},
			'minToDist' : {
				files : [ {
					src : [ 'target/build/min.html' ],
					dest : '<%= distfilepathmin %>'
				}, ],
			},
		},

		////////////////////////////////////////////////////////////
		//	╻┏┓╻┏━╸╻  ╻ ╻╺┳┓┏━╸   ┏━┓┏━╸┏━┓╻  ┏━┓┏━╸┏━╸
		//	┃┃┗┫┃  ┃  ┃ ┃ ┃┃┣╸ ╺━╸┣┳┛┣╸ ┣━┛┃  ┣━┫┃  ┣╸
		//	╹╹ ╹┗━╸┗━╸┗━┛╺┻┛┗━╸   ╹┗╸┗━╸╹  ┗━╸╹ ╹┗━╸┗━╸
		////////////////////////////////////////////////////////////
		includereplace : {
			'article' : {
				options : {
					includesDir : 'target/includes',
					processIncludeContents:function(txt,options){
						if (options['replace-type']){
							if (options['replace-type'] == 'no-cr'){
								txt = txt.replace(/(\r\n|\n|\r)/gm,"");
								//console.log(txt);
							}
						}
						return txt;
					}
				},
				//src : 'themes/<%=settings.theme%>/templates/index.html',
				src : 'target/includes/index.html',
				dest : 'target/build/article.handlebars',
			},

//			'article-html' : {
//				options : {
//					includesDir : 'target/includes',
//					suffix: '-html',
//					processIncludeContents:function(txt){
//						console.log("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@");
//						console.log(txt);
//						console.log("@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@");
//						return txt;
//					}
//				},
				//src : 'themes/<%=settings.theme%>/templates/index.html',
//				src : 'target/includes/index.html',
//				dest : 'target/build/article.handlebars'
//			},

			
//			'article-body' : {
//				options : {
//					includesDir : 'target/includes',
//				},
//				src : 'target/includes/article.xhtml',
//				dest : 'target/build/article.handlebars'
//			},

//			'article-xhtml' : {
//				options : {
//					includesDir : 'target/includes',
//				},
//				src : '<%=pr.src%>/article/article.html',
//				dest : 'target/includes/article-main.xhtml'
//			},

		},

	////////////////////////////////////////////////////////////
	//	┏━╸┏━┓┏┳┓┏━┓╻╻  ┏━╸   ╻ ╻┏━┓┏┓╻╺┳┓╻  ┏━╸┏┓ ┏━┓┏━┓┏━┓
	//	┃  ┃ ┃┃┃┃┣━┛┃┃  ┣╸ ╺━╸┣━┫┣━┫┃┗┫ ┃┃┃  ┣╸ ┣┻┓┣━┫┣┳┛┗━┓
	//	┗━╸┗━┛╹ ╹╹  ╹┗━╸┗━╸   ╹ ╹╹ ╹╹ ╹╺┻┛┗━╸┗━╸┗━┛╹ ╹╹┗╸┗━┛
	////////////////////////////////////////////////////////////
		'compile-handlebars' : {
			'article' : {
				template : 'target/build/article.handlebars',
				templateData : adata,
				helpers : [ 'build/helpers/**/*' ],
				output : 'target/build/article.xhtml'
			},
		},



		////////////////////////////////////////////////////////////
		//	┏━┓╻ ╻┏━╸╻  ╻
		//	┗━┓┣━┫┣╸ ┃  ┃
		//	┗━┛╹ ╹┗━╸┗━╸┗━╸
		////////////////////////////////////////////////////////////
		shell : {
			"rscript" : {
				command : 'Rscript --vanilla  ../../<%=pr.src%>/R/article-data.R',
				options : {
					execOptions : {
						cwd : 'target/rdata',
						env : adata['env'],
					}
				}
			},
			"libreoffice" : {
				command : 'libreoffice /tmp/article.txt',
				execOptions : {
					cwd : '.',
					env : adata['env'],
				}
			},
			"openoffice" : {
				command : 'openoffice.org3 /tmp/article.txt',
				execOptions : {
					cwd : '.',
					env : adata['env'],
				}
			},

			"show-env" : {
				options : {
					stdout : true,
					stderr : true,
					execOptions : {
						cwd : '.',
						env : adata['env'],
					}
				},
				command : 'set'
			},

		},

		////////////////////////////////////////////////////////////
		//	╻┏┳┓┏━┓┏━╸┏━╸┏┳┓╻┏┓╻
		//	┃┃┃┃┣━┫┃╺┓┣╸ ┃┃┃┃┃┗┫
		//	╹╹ ╹╹ ╹┗━┛┗━╸╹ ╹╹╹ ╹
		////////////////////////////////////////////////////////////
		imagemin : {
			'dist-org' : {
				files : [ {
					expand : true,
					flatten : true,
					src : [ '<%=pr.src%>/img/org/*.{gif,jpeg,jpg,png}' ],
					dest : '<%=pr.src%>/img/opt/',
				} ]
			},
			'dist-gen' : {
				files : [ {
					expand : true,
					flatten : true,
					src : [ '<%=pr.src%>/img/org/generated/*.{gif,jpeg,jpg,png}' ],
					dest : '<%=pr.src%>/img/opt/generated/',
				} ]
			},

		},

		////////////////////////////////////////////////////////////
		//	┏━┓╻ ╻┏━╸┏┳┓╻┏┓╻
		//	┗━┓┃┏┛┃╺┓┃┃┃┃┃┗┫
		//	┗━┛┗┛ ┗━┛╹ ╹╹╹ ╹
		////////////////////////////////////////////////////////////
		svgmin : {
			'dist-org' : {
				files : [ {
					expand : true,
					flatten : true,
					src : [ '<%=pr.src%>/img/org/*.svg' ],
					dest : '<%=pr.src%>/img/opt',
				} ]
			},
			'dist-gen' : {
				files : [ {
					expand : true,
					flatten : true,
					src : [ '<%=pr.src%>/img/org/generated/*.svg' ],
					dest : '<%=pr.src%>/img/opt/generated/',
				} ]
			}
		},



		cssmin: {
		  "font-awesome": {
		  	 files: {
		       'target/build/font-awesome.css': ['assets/css/font-awesome.css']
		     }
//		  	 files: [{
//		       expand: true,
//		       cwd: 'assets/css/',
//		       src: ['*.css', '!*.min.css'],
//		       dest: 'assets/css/',
//		       ext: '.min.css'
//		     }]
		  }
		},


		////////////////////////////////////////////////////////////
		//	╻┏┓╻╻  ╻┏┓╻┏━╸
		//	┃┃┗┫┃  ┃┃┗┫┣╸
		//	╹╹ ╹┗━╸╹╹ ╹┗━╸
		////////////////////////////////////////////////////////////
		inline : {
			'article' : {
				options : {
					tag : ''
				},
				src : [ 'target/build/watch.html' ],
				dest : [ 'target/build/inline.html' ]

			},
			'xarticle' : {
				options : {
					tag : '',
					mode: 'xhtml'
				},
				src : [ 'target/build/watch.xhtml' ],
				dest : [ 'target/build/inline.html' ]

			},

		},

		symlink : {
			options : {
				overwrite : false
			},
			"article-txt" : {
				src : '<%=pr.src%>/article/article.jade',
				dest : '/tmp/article.txt'
			}
		},


		htmlmin : {
			'article' : {
				options : {
					removeComments : true,
					removeAttributeQuotes : false,
					keepClosingSlash : true,
				  collapseWhitespace: true,
				 // conservativeCollapse: true,
				},
				files : {
					'target/build/min.html' : '<%= distfilepath %>',
				}
			},
		},

		less : {
			dist : {
				options : {
					paths : [ "<%=pr.src%>/less" ],
					cleancss : true,
					customFunctions:less_custom_functions,
					//modifyVars :adata['css'],
				},
				files : {
					//"target/build/style.css" : "<%=pr.src%>/less/style.less"
					"target/build/style.css" : "target/less/style.less"
				},
			},
			devel : {
				options : {
					paths : [ "<%=pr.src%>/less" ],
				    cleancss : false,
					customFunctions:less_custom_functions,
					//modifyVars :adata['css'],
				},
				files : {
					//"target/build/style.dev.css" : "<%=pr.src%>/less/style.less"
					"target/build/style.css" : "target/less/style.less"
				}
			}
		},


		prettify : {
			options : {},
			one : {
				src : 'target/build/watch.html',
				dest : 'target/build/watch-prt.html'
			}
		},

		validation: {
	    options: {
	        reset: grunt.option('reset') || false,
	        stoponerror: false,
	  	    relaxerror: ['Element link is missing required attribute property.'],
	    },
	    files: {
	        src: ['target/build/watch-prt.html']
	    },
		},

	  htmllint: {
      article: ["target/build/watch-prt.html"]
	  },


	  lint5: {
	    dirPath: "target/build",
	    defaults: {
	      },
	      templates: [
	        "watch-prt.html",
	      ],
	      ignoreList: [
	      ],
	    },



		watch : {
			html : {
				files : [ '<%=pr.src%>/article/**/*', '<%=pr.src%>/data/**/*' ],
				//tasks : [ 'article' ],
				tasks : [ 'make' ],
			},
			less : {
				files : [ '<%=pr.src%>/less/**/*' ],
				tasks : [ 'make' ]
			// [ 'style' ],
			}

		},

		markdown : {
			readme : {
				files : [ {
					expand : true,
					src : 'Readme.md',
					dest : '.',
					ext : '.html'
				} ]
			}
		},

		acat : {
			help : {
				file : 'etc/help.txt'
			},
		},

		clean : {
			target : {
				src : [ "target" ],
			},
		},

		mkdir : {
			target : {
				options : {
					create : [ 'target/build', 'target/rdata', 'target/dist' ]
				},
			},
		},
		
		

	});
	
	grunt.loadNpmTasks('grunt-contrib-jade');
	grunt.loadNpmTasks('grunt-include-replace');
	grunt.loadNpmTasks('grunt-shell');
	grunt.loadNpmTasks('grunt-contrib-watch');
	grunt.loadNpmTasks('grunt-contrib-copy');
	grunt.loadNpmTasks('grunt-contrib-clean');
	grunt.loadNpmTasks('grunt-mkdir');
	//grunt.loadNpmTasks('grunt-recess');
	grunt.loadNpmTasks('grunt-contrib-less');
	grunt.loadNpmTasks('grunt-compile-handlebars');
	grunt.loadNpmTasks('grunt-contrib-symlink');
	grunt.loadNpmTasks('grunt-contrib-htmlmin');
	grunt.loadNpmTasks('grunt-prettify');
	grunt.loadNpmTasks('grunt-markdown');
	//grunt.loadNpmTasks('grunt-replace');
	grunt.loadNpmTasks('grunt-svgmin');
	grunt.loadNpmTasks('grunt-contrib-imagemin');
	grunt.loadNpmTasks('grunt-contrib-cssmin');
	//grunt.loadNpmTasks('grunt-contrib-rename');
	grunt.loadNpmTasks('grunt-html');
	grunt.loadNpmTasks('grunt-html-validation');
	grunt.loadNpmTasks('grunt-lint5');


	grunt.loadTasks('build/tasks');


	grunt.registerTask('export-settings-json', 'export article data to json', function() {
		if (adata['R-org']){adata['R-in'] = adata['R-org'];}else if (!adata['R-in']){adata['R-in'] = adata['R'];}
		grunt.file.write('target/rdata/in/article.json', JSON.stringify(adata, null, 2));
	});

	grunt.registerTask('reload-data', 'reload-data', function() {
		adata = require('./build/src/load-data.js')(grunt);
	});
	grunt.registerTask('dump-data', 'dump-data', function() {
		console.log('------------------------------------------------');
		console.log(JSON.stringify(adata, undefined, 2));

	});

	grunt.registerTask('html', function() {
		var te = grunt.config.get("settings.template-engine");
		if (te.toUpperCase() == 'JADE') {
			grunt.task.run('html-jade');
		} else {
			grunt.task.run('html-xhtml');
		}
	});



	grunt.registerTask('minify', function(arg) {
		var base_name = grunt.config.get('settings.basename');
		if (arg == 'body') {
			grunt.config.set('distfilepathmin','dist/'+base_name + "-body.min.html");
			grunt.task.run('make:body');
			grunt.task.run('htmlmin:article');
			grunt.task.run('copy:minToDist');
		} else {
			grunt.config.set('distfilepathmin','dist/'+base_name + ".min.html");
			grunt.task.run('make');
			grunt.task.run('htmlmin:article');
			grunt.task.run('copy:minToDist');
		}
	});

	grunt.registerTask('make', function(arg) {
		var base_name = grunt.config.get('settings.basename');
		if (arg == 'xhtml') {
			grunt.config.set("make-body",false);
			grunt.config.set('distfilepath','dist/'+base_name + ".xhtml");
			grunt.task.run('_make-xhtml');
		} else if (arg == 'body') {
			grunt.config.set("make-body",true);
			grunt.config.set('distfilepath','dist/'+base_name + "-body.html");
			grunt.task.run('_make-html');
		} else {
			grunt.config.set("make-body",false);
			grunt.config.set('distfilepath','dist/'+base_name + ".html");
			grunt.task.run('_make-html');
		}
	});
	

	grunt.registerTask('finish', function(arg) {
		var default_project = grunt.config.get('pr.src');
		var final_file = grunt.config.get('distfilepath');
		console.log('project : ' + default_project);
		console.log('article : ' +final_file);
	});

	grunt.registerTask('exec-r', function(arg) {
		var default_project = grunt.config.get('pr.src');
		var rfile = default_project + "/R/article-data.R";
		if (grunt.file.exists(rfile)){
			grunt.task.run('_exec-r');
		} else {
			console.log("SKIPING R (source R/article-data.R not found)");
		}
	});

	grunt.registerTask('dump-r-data', function(arg) {
		//var default_project = grunt.config.get('pr.src');
		var rfile = 'target/rdata/R.json';
		if (grunt.file.exists(rfile)){
			console.log(JSON.stringify(grunt.file.readJSON(rfile), undefined, 2));
			//console.log(grunt.file.readJSON(rfile));
			console.log('------------------------------------------------');
		}
	});


	grunt.registerTask("help", [ "acat:help" ]);

	grunt.registerTask("optimize-images", [ "imagemin", "svgmin" ]);


	grunt.registerTask("_exec-r", ["shell:rscript", 'copy:rimages', 'copy:rdata','dump-r-data' ]);
	grunt.registerTask("rscript", [ "clear",  "export-settings-json", "exec-r" ]);
	grunt.registerTask("img-data", [ 'copy-images', 'get-img-data' ]);
	grunt.registerTask("libreoffice-jade", [ 'symlink:article-txt', 'shell:libreoffice' ]);
	grunt.registerTask("openoffice-jade", [ 'symlink:article-txt', 'shell:openoffice' ]);


	grunt.registerTask('prepare-style', [ 'copy:less-templates','copy:less-src','copy:less-variables','export-article-data-less' ]);
	grunt.registerTask("style", [ 'prepare-style','less:dist' ]);
	grunt.registerTask("style-dev", [ 'prepare-style','less:devel' ]);

	grunt.registerTask("html-rest",[ 'copy:templates','copy:template-fragments','copy:fragments-src','copy:includes-src']); //'includereplace:article-body-main']);

	grunt.registerTask("html-jade", [ 'jade', 'html-rest' ]);
	grunt.registerTask("html-xhtml", [ 'copy:article-html-src', 'html-rest' ]);

	//grunt.registerTask("import-article-data", [ 'import-generated-data' ]);
  grunt.registerTask("article", [  'html', 'includereplace:article', 'compile-handlebars:article' , 'dom-transform']);



	grunt.registerTask("_make-inline", [ "inline:article" ]);
	grunt.registerTask("_make-inline-x", [ "inline:xarticle" ]);


	grunt.registerTask("clear", [ "clean", "mkdir:target" ]);
	grunt.registerTask("copy-images", [ "copy:images-opt","copy:images-org" ]);
	grunt.registerTask("assets", [ "copy-images", "qrcode", "copy:js-theme","copy:js-src"  , "style", "copy:css","cssmin:font-awesome" ]);

	grunt.registerTask("_make-html", [ "clear", "assets", 'article', '_make-inline', 'copy:inlineToDist','finish' ]);
	grunt.registerTask("_make-xhtml", [ "clear", "assets", 'article', 'html2xhtml','_make-inline-x', 'copy:inlineToDist','finish' ]);

	grunt.registerTask('make-all', [ 'rscript', 'optimize-images', 'img-data', "reload-data", 'make' ]);
	grunt.registerTask("default", [ "help" ]);

	grunt.registerTask("validate", ['make', "prettify","validation" ]);
	//grunt.registerTask("validate-nu", ['make',  "prettify","htmllint" ]);
	//grunt.registerTask("validate-lint5", ['make',  "prettify","lint5" ]);


};
