module.exports = function (id,options) {

	var Handlebars  = require('handlebars');
	var data = options['data'];
	var handlebars_context = data['root'];
	var img_data = data['root']['images'][id];
//	console.log(img_data);

	var cheerio = require('cheerio');
	var $=  cheerio.load('<div>',{
	    	normalizeWhitespace: false,
	    	xmlMode: true,
	    	decodeEntities: false
			});
	var root = $('div');

	var float = 'right';
	if(img_data['float'] !== undefined && img_data['float'] != ''){
		float = img_data['float'];
	}
	var img_main_class = 'img';
	if(img_data['class'] !== undefined && img_data['class'] != ''){
		img_main_class = img_data['class'];
	}

	if (float == 'right'){
		img_class =  img_main_class + ' img-float-right';
	} else {
		img_class =  img_main_class + ' img-float-left';

	}
	var alt = img_data['alt'] !== undefined ? img_data['alt'] : '';

	root.attr('class',img_class);

	if (img_data['legend'] !== undefined && img_data['legend'] != ''){
		var span = $('<span>');
		var lclass = 'legend';
		if (img_data['legend']['width']){
			var n = img_data['legend']['width'];
			if (n>120){
				throw Error('legend width > 120');
			}
			lclass += ' width-chars-' + n;
		}
		span.attr('class',lclass);
		//span.attr('style','width: ' + img_data['legend']['width']);
		var tmp = Handlebars.compile(img_data['legend']['txt'])(handlebars_context);
		span.html(tmp);
		root.append(span);
	}

	var im = $('<img>');
	var img_id = 'img-' + id;
	im.attr('id',img_id);
	root.attr('id','div-img-' +id);
	im.attr('src',img_data['file']);
	im.attr('alt',alt );

	root.append(im);

	if (img_data['description'] !== undefined && img_data['description'] != ''){
		var p = $('<p>');
		p.attr('class','imgdesc');
		var tmp = Handlebars.compile(img_data['description'])(handlebars_context);
		p.html(tmp);
		root.append(p);
	}



	var attribution_flag = (img_data['attribution'] !== undefined && img_data['attribution'] != null);
	var description_flag = (img_data['description-long'] !== undefined && img_data['description-long'] !=null);
	var features_flag = (img_data['features']!== undefined && img_data['features'] != null);

	if (attribution_flag || descrption_flag ){

		//console.log(img_data);
		var img_title = 'image information';
		if (img_data['title'] !== undefined && img_data['title'] != ''){
			img_title = img_data['title'];
		}

		var span1 = null;
		var span2 = null;
		var span_features = null;

		if (description_flag){
			span1 = $('<div class="description">');
			var tmp = Handlebars.compile(img_data['description-long'])(handlebars_context);
			span1.html(tmp);
		}

		if (attribution_flag){
			span2 = $('<div class="attribution">');
			var span21 = $('<span>attribution:<br/></span>');
			var span22 = $('<span>');
			span2.append(span21);
			var title = img_data['attribution']['title'];
			if (img_data['attribution']['url'] !== undefined &&  img_data['attribution']['url']  != ''){
				var url = img_data['attribution']['url'];
				var a = $('<a>');
				a.attr('class','attribution-a external');
				a.attr('href',url);
				//a.attr('title',title);
				a.html(title);
				span22.append(a);
			}  else {
				span22.html(title);
			}
			span2.append(span22);
		}

		if (features_flag){
			span_features = $('<div class="features">');

			var format = img_data['features']['format'];
			var spanf2 = $('<div>');
			spanf2.text('format: ' + format);
			span_features.append(spanf2);


			var filesize = img_data['features']['filesize'];
			var spanf3 = $('<div>');
			spanf3.text('filesize: ' + filesize);
			span_features.append(spanf3);

			var geometry = img_data['features']['geometry'];
			var spanf4 = $('<div>');
			spanf4.text('geometry: ' + geometry);
			span_features.append(spanf4);

		}


		var divimg = $('<div class="dialog-img-cnt">');
		var imgimg = $('<img class="dialog-img" src="data:image/png;base64," >');
		imgimg.attr('alt',img_id);
		var body = $('<div>');
		divimg.append(imgimg);
		body.append(divimg);
		if (span1 != null) {body.append(span1);}
		if (span2 != null) {body.append(span2);}
		if (span_features != null) {body.append(span_features);}

		var div1 = $('<div>');
		div1.attr('class','modal img-dialog');
		div1.attr('aria-hidden','true');
		div1.attr('id','dialog-img-' + id);
		var div2 = $('<div>');div2.attr('class','modal-dialog');
		var div3 = $('<div>');div3.attr('class','modal-header');
		var h = $('<h2>');
		h.html(img_title);
		var b1 = $('<a>'); b1.attr('class','btn-close'); b1.attr('aria-hidden','true'); b1.attr('href','#!'); b1.text('×');
		var div4 = $('<div>'); div4.attr('class',"modal-body"); div4.append(body);

		var div5 = $('<div>'); div5.attr('class','modal-footer')
		var b2 = $('<a>'); b2.attr('class','btn');
		b2.attr('href','#!');
		b2.text('close');

		div1.append(div2);
		div2.append(div3);
		div3.append(h);
		div3.append(b1);
		div2.append(div4);
		div2.append(div5);
		div5.append(b2);


		root.append(div1);
	}


	//console.log($.html());
	//return $.html();
	return new Handlebars.SafeString($.html());

};



