'use strict';

module.exports = function(grunt) {


	grunt.registerTask('dom-transform', 'add id to p elements', function() {

		var debugbr = grunt.config.get('settings.style.debug-br',false);

		var replaceFlag = grunt.config.get('settings.p-add-id.enabled', true);
		var revision = grunt.config.get('settings.p-add-id.revision', 1);

			//var _ = require('lodash');
			//console.log(grunt.file.read('target/build/article.xhtml'));
			var opts={};
			var doc = autil.jsdomParseSync(grunt.file.read('target/build/article.xhtml')  ,opts);
			var window = doc.parentWindow;
			var $ = jquery(window);


			if (replaceFlag) {
				var addId = function(c,selector,idf){
					$(selector).each(function(idx,el){
						var el = $(el);
						var id = el.attr('id');
						if (! id) {
							c += 1;
							var id = 'r' + revision + idf + c;
							el.attr('id', id);
						}
					});
					return c;
				}

				var c;
				c = addId(0,'p','p');
				c = addId(0,'table','t');
				c = addId(0,'ol','l');
				c = addId(c,'ul','l');
			}


			if (debugbr){
				$( '<span class="debug-br">BR</span>' ).insertBefore( 'br' );
			}

			var ul = $('<ol>');
			$('h2.c-headline').each(function(idx,el){
				//console.log(idx, $(el).html());
				var el = $(el);
				var id = el.attr('id');
				var li = $('<li>');
				var a = $('<a>');
				a.attr('href','#'+id);
				a.html(el.text())
				li.html(a);
				ul.append(li);
			});


			//var toctitle = $('<div id="toctitle"><h2>Contents</h2><span class="toctoggle">&#160;[<a href="#noContents" id="toctogglelink">hide</a>]&#160;</span></div>');
			var toctitle = $('<div id="toctitle"><h2>Contents</h2></div>');
			var toc = $('#toc');
			toc.append(toctitle)
			toc.append(ul);

//			console.log('----------------------------------------');
//			console.log($('body').html());
//			console.log('----------------------------------------');

			var fout = 'target/build/watch.html';
			if (grunt.config.get('make-body')) {
				console.log("BODY -> " + fout);
				grunt.file.write(fout, $('body').html());
			} else {
				console.log("ARTICLE -> " + fout);
				var serializeDocument = require("jsdom").serializeDocument;
				grunt.file.write(fout, serializeDocument(doc));
			}
			//.replace(/^<html><head><\/head><body>/,'').replace(/<\/body><\/html>$/,'')


//		}else{
//			grunt.file.write('target/build/watch.html', grunt.file.read('target/build/article.xhtml'));
//		}
	});




//	grunt.registerTask('dom-transform2', 'add id to p elements', function() {
//
//		var debugbr = grunt.config.get('settings.style.debug-br',false);
//
//		var replaceFlag = grunt.config.get('settings.p-add-id.enabled', true);
//		var revision = grunt.config.get('settings.p-add-id.revision', 1);
//
//
//			var _ = require('lodash-node/underscore');
//
//			//var xmldom = require('xmldom');
//			var xmldom = require('../src/xmldom/dom-parser.js');
//			var XMLSerializer = xmldom.XMLSerializer;
//			var DOMParser = xmldom.DOMParser;
//
//			var html_entities = grunt.file.readJSON('./etc/entities.json');
//			var user_entities = grunt.config.get('settings.entities');
//			_.each(user_entities,function(entity,id){
//				html_entities[id] = entity;
//			});
//			var domParser = new DOMParser({
//				entityMap:html_entities,
//				xmlns:{'':'http://www.w3.org/1999/xhtml'},
//			});
//
//
//			var doc = domParser.parseFromString(grunt.file.read('target/build/article.xhtml'));
//
//			if (replaceFlag) {
//				var ps = doc.getElementsByTagName('p');
//				var c = 0;
//				_.each(ps, function(p, idx) {
//					var id = p.getAttribute('id');
//					if (id == '') {
//						c += 1;
//						var id = 'r' + revision + 'p' + c;
//						p.setAttribute('id', id);
//					}
//				});
//			}
//
//			if (debugbr){
//				var brs = doc.getElementsByTagName('br');
//				_.each(brs, function(br, idx) {
//					var parent = br.parentNode;
//					//console.log(parent.tagName);
//					var span =  doc.createElement("span");
//					span.setAttribute('class', "debug-br");
//					var txt = doc.createTextNode("BR");
//					span.appendChild(txt);
//					parent.insertBefore(span,br);
//				});
//
//			}
//
//			// var contents = doc.getElementById('contents');
//			// var hs = doc.getElementsByTagName('h1');
//			// _.each(hs,function(h,idx){
//			// var li = doc.createElement("li");
//			// _.each(h.childNodes,function(c,idx){
//			// var clone = c.cloneNode();
//			// li.appendChild(clone);
//			// });
//			// //console.log(new XMLSerializer().serializeToString(li));
//			// contents.appendChild(li);
//			// });
//
//
//			//var out = new XMLSerializer().serializeToString(doc);
////			out = out
////						.replace(/<i\s+class="(.*?)"\/>/g,function(matched, main){
////								 grunt.verbose.writeln('REPLACE i:',matched,"|",main);
////				 				return '<i class="'+ main +'"></i>';
////							});
//
//			console.log("transform: target/build/article.xhtml -> target/build/watch.xhtml")
//			grunt.file.write('target/build/watch.xhtml', new XMLSerializer().serializeToString(doc));
////	}else{
////		grunt.file.write('target/build/watch.xhtml', grunt.file.read('target/build/article.xhtml'));
////	}
//
//
//	});





grunt.registerTask('dom-test', 'Dom parser test', function() {
	var _ = require('lodash-node/underscore');
	var xmldom = require('../build/src/xmldom/dom-parser.js');
	var XMLSerializer = xmldom.XMLSerializer;
	var DOMParser = xmldom.DOMParser;

	var html_entities = grunt.file.readJSON('./etc/entities.json');
	var user_entities = grunt.config.get('settings.entities');
	_.each(user_entities,function(entity,id){
		html_entities[id] = entity;
	});
	var domParser = new DOMParser({
		entityMap:html_entities
	});
	var doc = domParser.parseFromString(grunt.file.read('target/build/article.xhtml'));
	grunt.file.write('target/build/dom-test.xhtml', new XMLSerializer().serializeToString(doc));
});







};
