'use strict';

module.exports = function(grunt) {

	grunt.registerTask('entities', 'generates etc/entities', function() {

		var Table = require('easy-table');
		var _ = require('lodash');
		var out = {};
		var fs = require('fs');
		var e = JSON.parse(fs.readFileSync('assets/html-entities.json'));
		_.each(e, function(entity, id) {
			var tmp = id;
			if (/;$/.test(tmp)) {
				tmp = tmp.substring(0, tmp.length - 1);
			}
			// else { console.log("@1",tmp);}

			if (/^\&/.test(tmp)) {
				tmp = tmp.substring(1, tmp.length);
			}
			// else { console.log("@2",tmp);}
			entity = entity['characters'];
			if (out[tmp] === undefined) {
				// console.log(id,':',tmp,'->',entity);
				out[tmp] = entity;
			} else {
				// console.log(id,">",tmp,"SAME KEY", out[tmp],"==",entity);
			}
		});

		//JSON.stringify(out, null, " ");
		grunt.file.write("etc/entities.json", JSON.stringify(out));
		console.log("etc/entities.json CREATED");

		var html = '<html><head><meta charset="UTF-8"/><style>table { font-size:1.2rem} </style></head><body><table border="1">';
		html += "\n";
		html += "<thead><tr><th>entity</th><th>rendered</th><th>char</th><th>charcode (hex)</th></tr></thead>\n";

		// var txt = '';
		var t = new Table;

		_.each(out, function(value, id) {
			// console.log(id);
			var entity = '&' + id + ';';
			var escaped = '&amp;' + id + ';';

			var charcode = '';
			var sep = '';
			for (var i = 0; i < value.length; i++) {
				var c = value.charCodeAt(i).toString(16).toUpperCase();
				charcode = charcode + sep + c;
				sep = ' ';
				// console.log(i,c,charcode);
			}

			// txt += ' ' + entity + ' : ' + value + ' ' + charcode +"\n";
			t.cell('entity', entity);
			t.cell('charcode (hex)', charcode);
			t.cell('value', value);
			t.newRow();

			html += "<tr><td>" + escaped + "</td><td>" + entity + "</td><td>" + value + "</td><td>" + charcode + "</td></tr>\n";

		});

		html += '</body></html>';

		grunt.file.write("etc/entities.html", html);
		console.log("etc/enitities.html CREATED");

		grunt.file.write("etc/entities.txt", t.toString());
		console.log("etc/enitities.txt CREATED");


	});

};