'use strict';

module.exports = function(grunt) {


	var _ = require('lodash');


	grunt.registerTask('projects','',function(arg){

		if (arguments.length === 0){
			arg = 'list';
		}


		var list = function(){
			var projects_path = grunt.config.get('options.projects_path');
			var fs = require('fs');
			_.each(projects_path,function(p,idx){
				var files = fs.readdirSync(p);
				_.each(files,function(file,idx){
					//console.log('  '  + p + ':');
					if (file[0] != '.'){
				         var filePath = p + '/' + file;
				         var stat = fs.statSync(filePath);
				         if (stat.isDirectory()){
				          	console.log(' ' + file + '  (' + p +') : projects:set-default:' + file );
				          }
				      }
				});
				//console.log("\n");
			});

			var default_project = grunt.config.get('pr.src');
			console.log("------------------------------------------------");
			console.log("DEFAULT PROJECT: " + default_project);
		};

		var setdefault = function(args){
			if (args.length < 2){
				console.log("project name expected");
			} else {

				var path = '';
				var project = args[1];
				var projects_path = grunt.config.get('options.projects_path');
				var fs = require('fs');
				_.each(projects_path,function(p,idx){
					var files = fs.readdirSync(p);
					_.each(files,function(file,idx){
						if (file == project){
					         var filePath = p + '/' + file;
					         var stat = fs.statSync(filePath);
					         if (stat.isDirectory()){
					        	 path = filePath;
					         }
					      }
					});
				});

				if (path != ''){
					var out = {'src':path};
					var storage = grunt.config.get('options.storage');
					grunt.file.write(storage, JSON.stringify(out, null, 2));
					console.log("DEFAULT PROJECT SET TO: " + path);
				}
			}

		}


		var getdefault = function(){
			var default_project = grunt.config.get('pr.src');
			console.log(default_project);
		}


		if (arg == 'list'){
			console.log(arg + ":");
			list();
		}else if (arg == 'set-default'){
			console.log(arg + ":");
			setdefault(arguments);
		}else if (arg == 'get-default'){
			getdefault(arguments);
		} else {
			console.log('unknown command ' + arg);
		}


	});




};
