'use strict';

module.exports = function(grunt) {


	var _ = require('lodash');


	grunt.registerTask('html2xhtml','',function(){
		   //var xmlserializer = require('../src/xmlserializer/serializer.js');
			var xmlserializer = require('xmlserializer');
			var Parser = require('parse5').Parser;
			var parser = new Parser();
			var dom = parser.parse(grunt.file.read('target/build/watch.html'));
			grunt.file.write('target/build/watch.xhtml',xmlserializer.serializeToString(dom));

	});

	grunt.registerTask('export-article-data-less','create less article-data.less',function(){
		//var _ = require('lodash-node/underscore');
		var parseVariableOptions = function(options) {
		    var pairs = _.pairs(options);
		    var output = '';
		    pairs.forEach(function(pair) {
		      output += '@' + pair[0] + ':' + pair[1] + ';'+"\n";
		    });
		    return output;
		  };
			var options = grunt.config.get('settings.style');
		  var less_txt = parseVariableOptions(options);
			grunt.file.write('target/less/article-data.less', less_txt);
	});



	grunt.registerTask('microdata-dump','dump article microdata',function(){

		var 	process = require('process');
		var microdata = require('node-microdata-parser');

		var done= this.async();

		microdata.parse(grunt.file.read('target/build/watch.html') , function(err, items) {
			if (err) { console.log(err)};
			console.log(items);
		  done();
		});

	});



//grunt import-data copy:images get-img-data

	grunt.registerTask('get-img-data','',function(){

		var asrc = grunt.config.get('settings.storage.src');

		var task  =this;
		var done = this.async();
		//var _ = require('lodash-node/underscore');

		var im = require('imagemagick');


		var images = grunt.config.get('settings.images-org');
		if (! images){
			images = grunt.config.get('settings.images');
		}

		var img_cnt = Object.keys(images).length;
		//console.log(images);
		//console.log(grunt.config.get('settings'));
		//console.log(images);
		//console.log(img_cnt);

		var export_data={};

		var i=0;
		_.each(images, function(img,id) {
			var file  = 'target/build/'+img.file;

			if( grunt.file.exists(file) ){
				//console.log(id,file);
				im.identify(file, function(err, data){
					if (err) throw err;
//					console.log('####################################');
//					  console.log("IDENTIFY",id,file);
//					console.log('------------------------');
//					console.log(data);
//					console.log('####################################');

					//img_data['id'] = {
					var img_data = {
						format: data.format,
						geometry: data.geometry,
						units: data.units,
						resolution: data.resolution,
						type: data.type,
						width: data.width,
						height: data.height,
						gamma: data.gamma,
						colorspace: data.colorspace,
						depth: data.depth,
						'print-size': data['print size'],
					  tainted: data['tainted'],
					  filesize: data['filesize'],
					  colors:data['colors'],
					  compression: data['compression'],
					  quality: data['quality'],
					  'orientation': data['orientation'],
					  'interlace': data['interlace'],
					  'background-color':data['background color'],
					  'border-color':data['border color'],
					  'matte-color':data['matte color'],
					  'transparent-color':data['transparent color'],
					  'compose': data['compose'],
					  'page-geometry':data['page geometry'],
					  'dispose': data['dispose'],
					  'profiles': data['profiles'],
					  'properties': data['properties'],
					};
					export_data[id] = {
							'features': img_data,
					};
					//images[id]['features'] = img_data;
					//console.log(img_data);
					i++;
					if (i>=img_cnt){
						console.log('WRITE: ' + asrc +"/data/generated/images.json");
						grunt.file.write(asrc+'/data/generated/images.json', JSON.stringify(export_data, null, 2));
						done();
					}
				});
			} else {
				console.log("IMG FILE: " + file + " NOT FOUND");
				img_cnt -=1;
			}



		});


	});





  grunt.registerMultiTask('acat', 'Echo a file to the console', function () {
  	var process = require('process');
    if (this.data.file) {
        	process.stdout.write((grunt.file.read(this.data.file)));
    }
    if (this.filesSrc) {
          grunt.util._.each(this.filesSrc, function (src) {
          	process.stdout.write(grunt.file.read(src));
          });
    }

		var default_project = grunt.config.get('pr.src');
		console.log("--------------------------------------------------");
		console.log("DEFAULT PROJECT: " + default_project);
  });







	grunt.registerTask('extract-markup-data','extract',function(){

			var _ = require('lodash');
			var xmldom = require('xmldom');
			var XMLSerializer = xmldom.XMLSerializer;
			var DOMParser = xmldom.DOMParser;



		  var getAttributes = function(element) {
        var org = element.attributes;
		  	var attributes = {};
        if( org.length ) {
            _.each( org, function( attr , index) {
                attributes[ attr.name ] = attr.value;
            } );
        }
        return attributes;
    };

			var doc = new DOMParser().parseFromString(grunt.file.read('target/build/watch.xhtml'));

			var els;

			console.log('=======================================================');
			console.log("H")
			console.log('=======================================================');

			els = doc.getElementsByTagName('h1');
			_.each(els,function(el,i){
				console.log(new XMLSerializer().serializeToString(el));
				});

			els = doc.getElementsByTagName('h2');
			_.each(els,function(el,i){
				console.log(new XMLSerializer().serializeToString(el));
			});

			console.log('=======================================================');
			console.log("SECTION")
			console.log('=======================================================');

			els = doc.getElementsByTagName('section');
			_.each(els,function(el,i){
				var attrs = getAttributes(el);
				console.log(attrs);
				console.log('--------------------');
			});

			console.log('=======================================================');
			console.log("ASIDE")
			console.log('=======================================================');

			els = doc.getElementsByTagName('aside');
			_.each(els,function(el,i){
				var attrs = getAttributes(el);
				console.log(attrs);
				console.log('--------------------');
			});


//			console.log('=======================================================');
//			console.log("DIV")
//			console.log('=======================================================');
//			els = doc.getElementsByTagName('div');
//			_.each(els,function(el,i){
//				var attrs = getAttributes(el);
//				//console.log(el.tagName);
//				console.log(attrs);
//				console.log('--------------------');
//			});

//			console.log('=======================================================');
//			console.log("A")
//			console.log('=======================================================');
//			els = doc.getElementsByTagName('a');
//			_.each(els,function(el,i){
//				var attrs = getAttributes(el);
//				//console.log(el.tagName);
//				console.log(attrs);
//				console.log('--------------------');
//			});


	});






	grunt.registerTask('_webshot', function(arg) {
		var base_name = grunt.config.get('settings.basename');
		var webshot = require('webshot');
		var img_file ='dist/'+base_name + '.png';
		var src_file = grunt.config.get('distfilepath');
		//console.log("img",img_file);
		//console.log("src",src_file);
		var done = this.async();

		var options = {
				siteType:'html',
			windowSize: {
	      width: 1152,
	      height: 864
		  },
		  shotSize: {
		      width: 1152,
		      height: 'all'
		  }
		}
		webshot(grunt.file.read(src_file), img_file, options, function(err) {
			if (err) {
				grunt.log.writeln('webshot error:');
				grunt.fail.warn(err);
				done(false);
				}
			console.log("img: ",img_file);
			done(true);
		});
	});


	grunt.registerTask('screenshot', function(arg) {
		grunt.task.run('make');
		grunt.task.run('_webshot');

	});




//var readXmlToString = function(file, options ){
//options = options === undefined ? {} : options;
//if (options['remove_xml_instruction'] === undefined){
//	options['remove_xml_instruction']  = false;
//}
//var xml = grunt.file.read(file);
//if (options['remove_xml_instruction']){
//	var position = xml.indexOf('\n');
//   if (position != -1) {
//   	if (xml.indexOf("<?xml") != -1){
//     	xml = xml.substr(position + 1);
//   	}
//   }
//}
//return xml;
//}
//
//var jsdomHtmlP2Parse = function(file,fn){
//var env = require('jsdom').env;
//var parser = require("htmlparser2");
//var xml = readXmlToString(file,{remove_xml_instruction:false});
//env(xml,{'parser':parser}, fn);
//}
//
//var jsdomParse5Parse = function(file,fn){
//var env = require('jsdom').env;
//var parser = require("parse5");
//var xml = readXmlToString(file,{remove_xml_instruction:true});
//env(xml,{'parser':parser}, fn);
//}
//
//var jsdomParse = function(file,fn){
//var env = require('jsdom').env;
//var xml = readXmlToString(file,{remove_xml_instruction:true});
//env(xml, fn);
//}
//
//
//grunt.registerTask('jdom-test','jdom-test',function(){
//console.log("jdom-test");
//var done = this.async();
//jsdomParse('./src/data/notes.xml',function (errors, window) {
//  console.log("ERRORS:",errors);
//  var $ = require('jquery')(window);
//  $('note').each(function(idx,el){
//  	console.log($(el).html());
//  });
//	done();
//});
//
//});
//
//grunt.registerTask('jdom-test2','jdom-test',function(){
//console.log("jdom-test");
//var done = this.async();
//jsdomParse5Parse('./src/data/notes.xml',function (errors, window) {
//  console.log("ERRORS:",errors);
//  var $ = require('jquery')(window);
//  $('note').each(function(idx,el){
//  	console.log($(el).html());
//  });
//	done();
//});
//
//});
//
//
//grunt.registerTask('jdom-test3','jdom-test',function(){
//console.log("jdom-test3");
//var done = this.async();
//jsdomHtmlP2Parse('./target/dist/normal-distribution.xhtml',function (errors, window) {
//  console.log("ERRORS:",errors);
//  var $ = require('jquery')(window);
//  $('p').each(function(idx,el){
//  	console.log($(el).html());
//  });
//	done();
//});
//
//});


//grunt.registerTask('jdom-test3','jdom-test',function(){
//console.log("jdom-test");
//var done = this.async();
//var jsdom = require('jsdom');
//var xml = readXmlToString('./target/dist/normal-distribution.xhtml',{remove_xml_instruction:false});
//var htmlparser2 = require("htmlparser2");
//var doc = jsdom.jsdom(xml, { parser: htmlparser2 });
//console.log(doc);
//
//});


}
