library(rjson);
jdata = list();

###################################################
## EXAMPLE 1
####################################################

img_width = 5;
img_height = 5;


json_data_input <- fromJSON(file="in/article.json");
xmin = json_data_input[['R-in']]$xmin;
xmax = json_data_input[['R-in']]$xmax;
step = json_data_input[['R-in']]$step;

x = seq(xmin,xmax,by=step);
y = -(x^2);

paste("plot.svg");
svg("plot.svg",width = img_width,height=img_height);
plot(x,y);
lines(x,y);
grid();
dev.off();


plot_data = list();
plot_data['ymin'] = min(y);
plot_data['ymax'] = max(y);




###################################################
## EXAMPLE 2
####################################################

set.seed(3200);
n = json_data_input[['R-in']]$n;
m= json_data_input[['R-in']]$m;
sd = json_data_input[['R-in']]$sd;


h <- sort(round(rnorm(n=n, m=m, sd=sd), digits = 0));
summary(h);


m=mean(h);
sd=sd(h);

nd = list();
nd['size'] = n;
nd['mean'] = round(m,1);
nd['sd'] = round(sd,1);
nd['median'] = median(h);
nd['unique'] = length(unique(h));

hmin = min(h);
hmax = max(h);
nd['min'] = hmin;
nd['max'] = hmax;



paste("normal.svg");
svg("normal.svg",width = img_width,height=img_height);
histbreaks = ceiling((hmax-hmin+1));
nd['bins3'] = histbreaks;
par(mar=c(4.2,4.2,3,1)); #BLTR
hist(h, prob=TRUE, ylim=c(0,.06), breaks=histbreaks,xlab="", main="",ylab="");
grid();
hist(h, prob=TRUE, add = TRUE, col="white", ylim=c(0,0.06), breaks=histbreaks,xlab="", main="");
title(main="PDF");
title(xlab="heigh");
title(ylab="Density");
#print(par());
curve(dnorm(x, m, sd), add=TRUE, col="red", lwd=3);
xmin=m-sd;
xmax=m+sd;
densities=dnorm(x,mean=m,sd=sd);
x2=seq(xmin,xmax,length=200);
y2=dnorm(x2,mean=m,sd=sd);
p1 = m-sd;
p2 = m+sd;
polygon(c(xmin,x2,xmax),c(0,y2,0),col="pink",density=6);
dev.off();







cat("========================================\n");
cat("JSON DATA\n");
cat("========================================\n");

jdata=list(plot=plot_data, nd=nd);

#cat(toJSON(jdata));

zz <- file("R.json", "w")  # open an output file connection
cat(toJSON(jdata), file = zz, sep = "\n")
close(zz)
