#library(Hmisc)

#########################
#INPUT
#########################
mym=180; #mean
std=12; #standardeviation

mym=120;
std=5;

###################
# constants
###################
#POLAPLASIASTIS

p=0.5;  #pi8anotita koronas


mym0=mym;
std0=std;

#ypologismoi dionimikis
##########################
n=ceiling(std0^2/(p*(1-p)));
q=1-p;
m=n*p; #mesos dionimikis
dd=sqrt(n*p*q); #tipiki apoklisi dionimikos
factor = m-mym;


#dionimiki
##########################
x=seq(0,n,by=1);
y=dbinom(x, size=n, prob=p); #dionimiki
x1=(x-m)/dd;  #kanonikopiisi (gia kentrarisma plot)

x=x-m; #kentrarisma sto 0
x=x+mym0;  #metakinisi sto meso oro




#ypologismos perigrafikon statistikon gia dionimiki
############################################
#
xy=x*y;
mm=sum(xy);  #MESOS OROS

sm1=(mm-x)^2*y
std1=sqrt(sum(sm1))  #TIPIKI APOKLISI

sm2=abs(mm-x)*y
std2=sum(sm2)        #STANDARD APOKLISI

minx = min(x);
maxx = max(x);
maxp = max(y);





# PLOTS
#############################################
## kentrarisma
df=subset(data.frame(x,y), abs(x1)<3.6);
plot_xmin = min(df$x);
plot_xmax = max(df$x);

#poligon x range
df=subset(data.frame(x,y), abs(x1)<=1.0);
pol_xmin1 = min(df$x);
pol_xmax1 = max(df$x);
df=subset(data.frame(x,y), abs(x1)<=2.0);
pol_xmin2 = min(df$x);
pol_xmax2 = max(df$x);
df=subset(data.frame(x,y), abs(x1)<=3.0);
pol_xmin3 = min(df$x);
pol_xmax3 = max(df$x);
df=subset(data.frame(x,y), abs(x1)<=4.0);
pol_xmin4 = min(df$x);
pol_xmax4 = max(df$x);


## kanoniki katanomi
xn=x;
ynormal=dnorm(xn,mean=mym, sd=std);
ynormal=ynormal;

## oria y a3ona
plot_ymax = max(ynormal);
plot_ymin = min(ynormal);
#plots
title = paste('binomial n:',n,'normal mean:',round(mym,2),' std:',round(std,2));
# plot dionimikis
plot(x,y,main=title,ylab='p',xlab='n',xlim=c(plot_xmin,plot_xmax),ylim=c(plot_ymin,plot_ymax));
#points(xn,ynormal,col="yellow",  type="o", pch=20); # simia kanonikis
lines(xn,ynormal,col="green"); # line kanonikis
#vertical lines
yln=seq(-1,1,length=10);
lines(rep(pol_xmin1,10),yln,col="bisque4");
lines(rep(pol_xmax1,10),yln,col="bisque4");
lines(rep(pol_xmin2,10),yln,col="bisque4");
lines(rep(pol_xmax2,10),yln,col="bisque4");
lines(rep(pol_xmin3,10),yln,col="bisque4");
lines(rep(pol_xmax3,10),yln,col="bisque4");

lines(rep(mym,10),yln,col="red");

grid();


cat('
----------------
kanoniki
----------------
mean     = ',mym,'
std      = ',std,'
<1*std   = ',pol_xmin1, '-',pol_xmax1,'
<2*std   = ',pol_xmin2, '-',pol_xmax2,'
<3*std   = ',pol_xmin3, '-',pol_xmax3,'
<4*std   = ',pol_xmin4, '-',pol_xmax4,'
----------------
dionimiki
----------------
n        = ',n,'
factor1   = ',factor,' (gia xrisi sto simulation)
----------------
mean     = ',m,'
std      = ',dd,'
mm       = ',mm,'
ds2 (std)= ',std1,'
ds2 (abs)= ',std2,'
min(x)   = ',minx,'
max(x)   = ',maxx,'
max(p)   = ',maxp,'
-------------------',
"\n");

sum(y);
sum(ynormal);


#factor1=100;
#factor2=10;
