#library(plotrix);

m=180; #mean
sd=8;  #standar deviation
n=200;  #number of samples
set.seed(3200);

h <- sort(round(rnorm(n=n, m=m, sd=sd), digits = 0));
summary(h);
freqs = as.data.frame(table(h));

hmin = min(h);
hmax = max(h);


plot(h);grid();
#hist(h, prob=TRUE, ylim=c(0,.06), breaks=histbreaks,main="histogram",xlab="heigh")

boxplot(h);

x=as.numeric(levels(freqs$h));
x
y=freqs$Freq;
barp(y,names.arg=x,main="barplot",
     ylab="Freq",
     xlab="height",
     col = "lightgrey");



xp=y/n;
sum(xp);
barp(xp,names.arg=x,
		main="barplot",
		ylab="Prob",
		xlab="height",
		col = "lightgrey");


probs = data.frame(x,xp);
#p1=subset(probs,x==160)$xp;

#hist(h, prob=TRUE, ylim=c(0,.06), breaks=histbreaks,main="PDF",xlab="heigh")
#curve(dnorm(x, m, sd), add=TRUE, col="red", lwd=3);grid();




histbreaks = ceiling((hmax-hmin+1));
hist(h, prob=TRUE, ylim=c(0,.06), breaks=histbreaks,main="PDF",xlab="heigh")
curve(dnorm(x, m, sd), add=TRUE, col="red", lwd=3);grid();
xmin=183;
xmax=183;
xmax2= xmax+1;
densities=dnorm(x,mean=m,sd=sd)

x2=seq(xmin,xmax2,length=200)
y2=dnorm(x2,mean=m,sd=sd)
polygon(c(xmin,x2,xmax2),c(0,y2,0),col="pink",density=50);


pt1 = 0;
for (i in xmin:(xmax2-1)){
  cat("i=",i,"\n");
  tmp = subset(probs,x==i)$xp;
  if (length(tmp)>0){
    pt1 = pt1+tmp;
    cat("pt1=",pt1,"\n");
  }
}

pt2= pnorm(xmax2,mean=m,sd=sd)-pnorm(xmin,mean=m,sd=sd);
pt1;
pt2;
abs(pt1-pt2);








# NORMALITY  TEST
#hist(h);
#plot(density(h));grid();
#qqnorm(h);qqline(h, col = 2);grid();
